//  Interface.cpp
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Interface.h"
#include "UAbout.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

//  
#define PATH "Pictures\\"
//#define PATH ""

TMainForm *MainForm;
//---------------------------------------------------------------------------
//  
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
 diceImage = new TJPEGImage(); //  Referee.NewGame()
 if(!diceImage){//   
   ShowMessage("      !");
   Close();
 }
// Image->Picture = (TPicture *) diceImage;
 Referee.NewGame();
//  
 diceImage->LoadFromFile(AnsiString(PATH) + "0.jpg");
 Image->Picture = (TPicture *) diceImage;
}
//---------------------------------------------------------------------------

//      
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
 if(diceImage){ //    
   delete diceImage;
   diceImage = NULL; //    
 }
}
//---------------------------------------------------------------------------

// 
void __fastcall TMainForm::GameExitItemClick(TObject *Sender)

{
// Close();
 Perform(WM_CLOSE, 0, 0); //   
}
//---------------------------------------------------------------------------

//     
void TMainForm::ShowInfo(TMessage &a)
{
//   
 if(Referee.GetActiveMember() == PLAYER){
   ActivePlayer->Caption = " ";
   PlayerGroupBox->Enabled = true;
   PartnerGroupBox->Enabled = false;
   PlayerGroupBox->Font->Style =
                   TFontStyles()<< fsBold;
   PartnerGroupBox->Font->Style = TFontStyles();
 }
 else{
   ActivePlayer->Caption = " ";
   PartnerGroupBox->Enabled = true;
   PlayerGroupBox->Enabled = false;
   PartnerGroupBox->Font->Style = TFontStyles()<< fsBold;
   PlayerGroupBox->Font->Style = TFontStyles();
 }
 
 PlayerCurrentScores->Text = IntToStr(Referee.Player.GetCurrentScores());
 PlayerSumScores->Text = IntToStr(Referee.Player.GetSumScores());
 PartnerCurrentScores->Text = IntToStr(Referee.Partner.GetCurrentScores());
 PartnerSumScores->Text = IntToStr(Referee.Partner.GetSumScores());
 PlayCount->Caption = IntToStr(Referee.GetPlayCount());
 ShowDice();
 PlayerVictoryCount->Text = IntToStr(Referee.Player.GetVictoryCount());
 PartnerVictoryCount->Text = IntToStr(Referee.Partner.GetVictoryCount());
// Balance->Caption = "  " + PlayerVictoryCount->Text
//                    + " : "  + PartnerVictoryCount->Text;
 Balance->Caption = "  " + IntToStr(Referee.Player.GetVictoryCount())
                    + " : " + IntToStr(Referee.Partner.GetVictoryCount());
 GameFinishScores->Caption = "  "
                              + IntToStr(GAME_FINISH_SCORES);                      
}
//---------------------------------------------------------------------------

//     
void TMainForm::ShowDice()
{
 AnsiString fileName = PATH;
 fileName += IntToStr(Referee.Dice.GetDiceValue());
 fileName += ".jpg";
 try{ //  
   // Image->Picture->LoadFromFile(fileName);
   diceImage->LoadFromFile(fileName);
//    
   Image->Picture = (TPicture *) diceImage;
 }
 catch(...){//   ,   
   ShowMessage("     -  " + fileName);
 }
}
//---------------------------------------------------------------------------

//    
void __fastcall TMainForm::PartnerStepClick(TObject *Sender)
{
 Referee.Move();
//  
 diceImage->LoadFromFile(AnsiString(PATH) + "0.jpg");
 Image->Picture = (TPicture *) diceImage;
}
//---------------------------------------------------------------------------

//  
void __fastcall TMainForm::NewGameItemBtnClick(TObject *Sender)
{
 Referee.NewGame();
//  
 diceImage->LoadFromFile(AnsiString(PATH) + "0.jpg");
 Image->Picture = (TPicture *) diceImage;
}
//---------------------------------------------------------------------------

//   
void __fastcall TMainForm::StepClick(TObject *Sender)
{
//     
 TPlayer *ptrMember; //   
//     
 if(Referee.GetActiveMember() == PLAYER)
   ptrMember = &Referee.Player;
 else
   ptrMember = &Referee.Partner;

 TMainForm::ptrMember = ptrMember;//    
                                 //   
 Referee.Dice.Action();//  
 if(Referee.Dice.GetDiceValue() == 1){//  
   ptrMember->AddCurrentScores(-ptrMember->GetCurrentScores());
   Referee.Move();
   return;
 }
//     -   
 ptrMember->AddCurrentScores(Referee.Dice.GetDiceValue());
/*
    ptrMember
 if(Referee.GetActiveMember() == PLAYER)
   Referee.Player.AddCurrentScores(Referee.Dice.GetDiceValue());
 else
   Referee.Partner.AddCurrentScores(Referee.Dice.GetDiceValue());
*/
//     
 if(Referee.GameFinish()){
//    .   .
   ptrMember->AddVictoryCount();//   
   Beep(); // 
   Referee.NewGame();
   ShowMessage(" !"); // 
 }
 else //  ,   
   Perform(MY_SHOW, 0, 0);//  
                          //  
}
//---------------------------------------------------------------------------

//  -   
void __fastcall TMainForm::PartyBtnClick(TObject *Sender)
{
 if(Referee.GetActiveMember() == PLAYER)
   Referee.Partner.AddVictoryCount();
 else
   Referee.Player.AddVictoryCount();
 Referee.NewGame();
//  
 diceImage->LoadFromFile(AnsiString(PATH) + "0.jpg");
 Image->Picture = (TPicture *) diceImage;
}
//---------------------------------------------------------------------------

//   
void __fastcall TMainForm::ClearImageBtnClick(TObject *Sender)
{
 try{ //  
   diceImage->LoadFromFile(AnsiString(PATH) + "0.jpg");
   Image->Picture = (TPicture *) diceImage;
 }
 catch(...){//   ,   
   ShowMessage("     -  \" 0.jpg! \" ");
   // \" -     
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AboutClick(TObject *Sender)
{
 AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

